from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_core.utils.json_processor import JSONProcessor
from cpl_query.extension import List

from modules.permission.configuration.permission_server_settings import (
    PermissionServerSettings,
)


class PermissionSettings(ConfigurationModelABC):
    def __init__(self, **kwargs: dict):
        ConfigurationModelABC.__init__(self)

        self._servers: List[PermissionServerSettings] = List()
        for s in kwargs:
            kwargs[s]["Id"] = s
            self._servers.append(JSONProcessor.process(PermissionServerSettings, kwargs[s]))

    @property
    def servers(self) -> List[PermissionServerSettings]:
        return self._servers
